#!/bin/sh
# the next line restarts using wish \
exec wish "$0" "$@"

###############################################################################
#                                                                             #
#    TkAvGate 1.00.00 - Frontend fuer H+BEDV AntiVir MailGate for Linux       #
#    Copyright (C) 2001-2003 Sebastian Geiges                                 #
#                                                                             #
#    AntiVir ist ein registriertes Warenzeichen der H+BEDV Datentechnik GmbH. #
#                                                                             #
#    This program is free software; you can redistribute it and/or modify     #
#    it under the terms of the GNU General Public License as published by     #
#    the Free Software Foundation; either version 2 of the License, or        #
#    (at your option) any later version.                                      #
#                                                                             #
#    This program is distributed in the hope that it will be useful,          #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of           #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            #
#    GNU General Public License for more details.                             #
#                                                                             #
#    You should have received a copy of the GNU General Public License        #
#    along with this program; see the file COPYING.  If not, write to         #
#    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,         #
#    Boston, MA 02111-1307, USA.                                              #
#                                                                             #
###############################################################################

# Abfrage nach der Tcl/Tk-Version
if { $tk_version != "8.0" && $tk_version != "8.1" && $tk_version != "8.2" && $tk_version != "8.3" && $tk_version != "8.4"} {
  puts "\a\n***************************************************************************"
  puts "*                                                                         *"     
  puts "*   TkAvGate 1.00 benoetigt mindestens Tcl/Tk Version 8.0 oder hoeher!    *"
  puts "*   Im Moment werden die Versionen 8.0.x bis 8.4 unterstuetzt.            *"
  puts "*   Tcl/Tk 8.x oder erhalten Sie unter http://www.scriptics.com/          *"
  puts "*   oder evtl. auch von Ihrem Linux-Distributor.                          *"
  puts "*                                                                         *"
  puts "*   Sie benutzen im Moment Tcl $tcl_version und Tk $tk_version.                            *"
  puts "*                                                                         *"
  puts "***************************************************************************\n"
  exit
}

# globale Variable
set path_to_tkavgate "/usr/X11R6/lib/TkAvGate"
set user "uucp"
set group "uucp"
set hostname ""
set spooldir "/var/spool/avmailgate"
set antivirdir "/usr/lib/AntiVir"
set tempdir "/var/tmp"
set postmaster "postmaster"
set smtpbanner "AntiVir MailGate"
set matchmail "RECIPIENT"
set piddir "/var/tmp"
set address "0.0.0.0"
set port "smtp"
set timeout "300"
set maxforward "10"
set blockmime "0"
set exposealerts "0"
set exposesenderalerts "0"
set exposepostmasteralerts "1"
set virusalertsuser "AvMailGate"
set statusinbody "0"
set mimeconvert "0"
set pollperiod "60"
set scanarc "1"
set maxarcrecon "0"
set maxarcrec "0"
set maxarcsizeon "0"
set maxarcsize "0"
set minfreeon "1"
set minfree "100"
set maxrecon "1"
set maxrec "100"
set blockarc "0"
set blockencarc "0"
set addxheader "1"
set bouncemessageuser "MAILER-DAEMON"
set addrheader "1"
set scantimeout "300"
set externalprogram ""
set maxnesting "20"
set maxattachments "100"
set sourcerouting "0"
set addressbang "REFUSED"
set addresspercent "REFUSED"
set loosedomainname "0"
set forwardtosendmail "/usr/bin/sendmail -oem -oi"
set forwardtosmtp "SMTP: localhost port smtp-backdoor"
set forwardto $forwardtosendmail
set refuseemptyfrom "0"
set buttonpressed -1
set buttonpressededit -1
set buttonpressedadd -1
set buttonpressedmod -1


#####################################################################
# Liest die Konfiguartion ein                                       #
#####################################################################
proc gate_load {} {

  # globale Optionen
  global user
  global group
  global hostname
  global spooldir
  global antivirdir
  global tempdir
  global postmaster
  global smtpbanner
  global piddir
  global address
  global port
  global timeout
  global maxconnon
  global maxconn
  global maxsizeon
  global maxsize
  global maxrecon
  global maxrec
  global minfreeon
  global minfree
  global maxforward
  global maxnesting
  global maxattachments
  global blockmime
  global exposealerts
  global exposesenderalerts
  global exposepostmasteralerts
  global virusalertsuser
  global statusinbody
  global mimeconvert
  global pollperiod
  global scanarc
  global maxarcrecon
  global maxarcrec
  global maxarcsizeon
  global maxarcsize
  global blockarc
  global blockencarc
  global bouncemessageuser
  global addxheader
  global addrheader
  global scantimout
  global externalprogram
  global forwardto
  global refuseemptyfrom
  global sourcerouting
  global addressbang
  global addresspercent
  global loosedomainname
   
  # nur versuchen die Datei zu oeffnen, wenn sie auch da ist, um
  # laestige Fehlermeldungen zu verhindern
  if { [file exists "/etc/avmailgate.conf"] > 0} {
   
    # Datei zum Lesen oeffnen  
    set File1 [open "/etc/avmailgate.conf" r]
      
    # Zeilenweise bis Dateiende lesen      
    while {[gets $File1 line] > -1} {

      # Formatierung entfernen
      set line [string trim $line]

      # Kommentare ignorieren    
      if {[string first "" "$line"] == 0} continue

        # String fuer User
        if {[string first "User" "$line"] == 0} {
          set user [string range $line 6 end]
          set user [string trim $user]
      	 } 
	   
        # String fuer Gruppe
        if {[string first "Group" "$line"] == 0} {
          set group [string range $line 6 end]
          set group [string trim $group]
        } 

        # String fuer Gruppe
        if {[string first "MyHostName" "$line"] == 0} {
          set hostname [string range $line 11 end]
          set hostname [string trim $hostname]
        } 
        
       	# String fuer Spool-Verzeichnis auslesen
        if {[string first "SpoolDir" "$line"] == 0} {
          set spooldir [string range $line 9 end]
          set spooldir [string trim $spooldir]
        } 

       	# String fuer AntiVir-Verzeichnis wg. VDF auslesen
        if {[string first "AntiVirDir" "$line"] == 0} {
          set antivirdir [string range $line 11 end]
          set antivirdir [string trim $antivirdir]
        } 

       	# String fuer TEMP-Verzeichnis wg. VDF auslesen
        if {[string first "TemporaryDir" "$line"] == 0} {
          set tempdir [string range $line 13 end]
          set tempdir [string trim $tempdir]
        } 

        	 
        # String fuer Postmaster lesen
        if {[string first "Postmaster" "$line"] == 0} {
          set postmaster [string range $line 11 end]
          set postmaster [string trim $postmaster]
        } 

        # String fuer SMTP-Begruessungsnachricht lesen
        if {[string first "SMTPBanner" "$line"] == 0} {
          set smtpbanner [string range $line 11 end]
          set smtpbanner [string trim $smtpbanner]
          set smtpbanner [string range $smtpbanner 1 end-1]
        } 
      	 
        # String fuer PID
        if {[string first "PidDir" "$line"] == 0} {
          set piddir [string range $line 7 end]
          set piddir [string trim $piddir]
        }

        # String fuer Adresse und Port
        if {[string first "ListenAddress" "$line"] == 0} {
          set addressstr [string range $line 14 end]
          set addressstr [string trim $addressstr]
          regsub "port" $addressstr "       " addressstr
          set address [string range $addressstr 0 15]
          set address [string trim $address]
          set port [string range $addressstr 15 end]
          set port [string trim $port]
        }

        # String fuer Port (alte Methode)
        if {[string first "ListenPort" "$line"] == 0} {
          set port [string range $line 11 end]
          set port [string trim $port]
        }

        # String fuer SMTP-Timeout
        if {[string first "SmtpTimeout" "$line"] == 0} {
          set timeout [string range $line 12 end]
          set timeout [string trim $timeout]
        }

        # String fuer max Verb.
        if {[string first "MaxIncomingConnections" "$line"] == 0} {
          set maxconn [string range $line 23 end]
          set maxconn [string trim $maxconn]
          if {[string compare "$maxconn" "0"] == 0} {
            set maxconnon "0"
       	    set maxconn ""
          } else {
            set maxconnon "1"
          }               
        }

        # String fuer Nachrichtengroesse
        if {[string first "MaxMessageSize" "$line"] == 0} {
          set maxsize [string range $line 16 end]
          set maxsize [string trim $maxsize]
          if {[string compare "$maxsize" "0"] == 0} {
	        set maxsizeon "0"
            set maxsize ""
          } else {
            set maxsizeon "1"
          }
       }
       
       # String fuer Anzahl der Empfnger
       if {[string first "MaxRecipientsPerMessage" "$line"] == 0} {
         set maxrec [string range $line 24 end]
         set maxrec [string trim $maxrec]
         set maxrecon "1"
       }

       # String fuer freie Blcke auf FS
       if {[string first "MinFreeBlocks" "$line"] == 0} {
         set minfree [string range $line 14 end]
         set minfree [string trim $minfree]
         set minfreeon "1"
       }
       
       # Absenderlose Mails ignorieren
       if {[string first "RefuseEmptyMailFrom" "$line"] == 0} {
         set refuseemptyfrom [string range $line 20 end]
         set refuseemptyfrom [string trim $refuseemptyfrom]
         if {[string compare "$refuseemptyfrom" "YES"] == 0} {
           set refuseemptyfrom "1"
         } else {
           set refuseemptyfrom "0"
         }
       }

       # Source-Routinng erlauben
       if {[string first "AllowSourceRouting" "$line"] == 0} {
         set sourcerouting [string range $line 20 end]
         set sourcerouting [string trim $sourcerouting]
         if {[string compare "$sourcerouting" "YES"] == 0} {
           set sourcerouting "1"
         } else {
           set sourcerouting "0"
         }
       }

       # Behandlung von Ausrufezeichen in Envelope-Adressen
       if {[string first "InEnvelopAddressesBangIs" "$line"] == 0} {
         set addressbang [string range $line 24 end]
         set addressbang [string trim $addressbang]
       } 
       
       # Behandlung von Prozenntzeichen in Envelope-Adressen
       if {[string first "InEnvelopAddressesPercentIs" "$line"] == 0} {
         set addresspercent [string range $line 27 end]
         set addresspercent [string trim $addresspercent]
       } 

       # Nicht-syntax-konforme Domainnamen zulassen
       if {[string first "AcceptLooseDomainName" "$line"] == 0} {
         set loosedomainname [string range $line 22 end]
         set loosedomainname [string trim $loosedomainname]
         if {[string compare "$loosedomainname" "YES"] == 0} {
           set loosedomainname "1"
         } else {
           set loosedomainname "0"
         }
       }
        
       # Max. Anzahl simultam laufender Forwarder
       if {[string first "MaxForwarders" "$line"] == 0} {
         set maxforward [string range $line 14 end]
         set maxforward [string trim $maxforward]
       }

       # Max. MIME-Nesting
       if {[string first "MaxNestingLevel" "$line"] == 0} {
         set maxnesting [string range $line 16 end]
         set maxnesting [string trim $maxnesting]
       }
       
       # Maximale Anzahl an Mailanhngen
       if {[string first "MaxAttachments" "$line"] == 0} {
         set maxattachments [string range $line 15 end]
         set maxattachments [string trim $maxattachments]
       }

        
       # Verdaechtige Mime-Mails blocken
       if {[string first "BlockSuspiciousMime" "$line"] == 0} {
         set blockmime [string range $line 20 end]
         set blockmime [string trim $blockmime]
         if {[string compare "$blockmime" "YES"] == 0} {
           set blockmime "1"
         } else {
           set blockmime "0"
         }
       }
    
       # Virenwarnung an externe Empfnger infiz. Mails
       if {[string first "ExposeRecipientAlerts" "$line"] == 0} {
         set exposealerts [string range $line 22 end]
         set exposealerts [string trim $exposealerts]
         if {[string compare "$exposealerts" "YES"] == 0} {
           set exposealerts "1"
         } else {
           set exposealerts "0"
         }
       }

       # Virenwarnung an externe Absender infiz. Mails
       if {[string first "ExposeSenderAlerts" "$line"] == 0} {
         set exposesenderalerts [string range $line 19 end]
         set exposesenderalerts [string trim $exposesenderalerts]
         if {[string compare "$exposesenderalerts" "YES"] == 0} {
           set exposesenderalerts "1"
         } else {
           set exposesenderalerts "0"
         }
       }

       # Virenwarnung an Postmaster
       if {[string first "ExposePostmasterAlerts" "$line"] == 0} {
         set exposepostmasteralerts [string range $line 23 end]
         set exposepostmasteralerts [string trim $exposesenderalerts]
         if {[string compare "$exposepostmasteralerts" "YES"] == 0} {
           set exposepostmasteralerts "1"
         } else {
           set exposepostmasteralerts "0"
         }
       }
        
       # Forwarder
       if {[string first "ForwardTo" "$line"] == 0} {
         set forwardto [string range $line 10 end]
         set forwardto [string trim $forwardto]
       }

       # Absender von Viren-Warnungen
       if {[string first "VirusAlertsUser" "$line"] == 0} {
         set virusalertsuser [string range $line 16 end]
         set virusalertsuser [string trim $virusalertsuser]
       }
        
       # Status in Mail-Body
       if {[string first "AddStatusInBody" "$line"] == 0} {
         set statusinbody [string range $line 16 end]
         set statusinbody [string trim $statusinbody]
         if {[string compare "$statusinbody" "YES"] == 0} {
           set statusinbody "1"
         } else {
           set statusinbody "0"
         }
       }       
       # Mails immer als MIME weiterleiten
       if {[string first "ForwardAllEmailAsMIME" "$line"] == 0} {
         set mimeconvert [string range $line 23 end]
         set mimeconvert [string trim $mimeconvert]
         if {[string compare "$mimeconvert" "YES"] == 0} {
           set mimeconvert "1"
         } else {
           set mimeconvert "0"
         }
       }
        
        # Pollperiod
        if {[string first "PollPeriod" "$line"] == 0} {
          set pollperiod [string range $line 11 end]
          set pollperiod [string trim $pollperiod]
        }

        
       # Archvidateien durchsuchen
       if {[string first "ScanInArchive" "$line"] == 0} {
         set scanarc [string range $line 14 end]
         set scanarc [string trim $scanarc]
         if {[string compare "$scanarc" "YES"] == 0} {
           set scanarc "1"
         } else {
           set scanarc "0"
         }
       }
        
       # verdchtige Archive blockieren
       if {[string first "BlockSuspiciousArchive" "$line"] == 0} {
         set blockarc [string range $line 23 end]
         set blockarc [string trim $blockarc]
         if {[string compare "$blockarc" "YES"] == 0} {
           set blockarc "1"
         } else {
           set blockarc "0"
         }
       } 

       # Archive mit verschlsselten Dateien blockieren
       if {[string first "BlockEncryptedArchive" "$line"] == 0} {
         set blockencarc [string range $line 22 end]
         set blockencarc [string trim $blockencarc]
         if {[string compare "$blockencarc" "YES"] == 0} {
           set blockencarc "1"
         } else {
           set blockencarc "0"
         }
       }
        
       # Max. Archivtiefe
        if {[string first "MaxRecursionDepthInArchive" "$line"] == 0} {
          set maxarcrec [string range $line 26 end]
          set maxarcrec [string trim $maxarcrec]
          if {[string compare "$maxarcrec" "0"] == 0} {
       	    set maxarcrecon "0"
            set maxarcrec ""
          } else {
            set maxarcrecon "1"
          }
       }

       # Max. Dateigre in Archiven
        if {[string first "MaxFilesizeInArchive" "$line"] == 0} {
          set maxarcsize [string range $line 20 end]
          set maxarcsize [string trim $maxarcsize]
          if {[string compare "$maxarcsize" "0"] == 0} {
       	    set maxarcsizeon "0"
            set maxarcsize ""
          } else {
            set maxarcsizeon "1"
          }
       }

       # BounceMessageUser
       if {[string first "BounceMessageUser" "$line"] == 0} {
         set bouncemessageuser [string range $line 18 end]
         set bouncemessageuser [string trim $bouncemessageuser]
       }
        
       # X-Header hinzufgen
       if {[string first "AddXHeader" "$line"] == 0} {
         set addxheader [string range $line 11 end]
         set addxheader [string trim $addxheader]
         if {[string compare "$addxheader" "YES"] == 0} {
           set addxheader "1"
         } else {
           set addxheader "0"
         }
       }

       # Received by-Header hinzufgen
       if {[string first "AddReceivedByHeader" "$line"] == 0} {
         set addrheader [string range $line 20 end]
         set addrheader [string trim $addrheader]
         if {[string compare "$addrheader" "YES"] == 0} {
           set addrheader "1"
         } else {
           set addrheader "0"
         }
       }

       # Scan-Timeout
       if {[string first "ScanTimeout" "$line"] == 0} {
         set scantimeout [string range $line 12 end]
         set scantimeout [string trim $scantimeout]
       }

       # Program ausfhren bei Virenfund
       if {[string first "ExternalProgram" "$line"] == 0} {
         set externalprogram [string range $line 16 end]
         set externalprogram [string trim $externalprogram]
       }
        
        
    }
    # Datei wieder schliessen
    close $File1
 
  }

  update idletask
               
}


#####################################################################
# Speichert die Konfiguartion ab                                    #
#####################################################################
proc gate_save {} {

  # globale Optionen
  global user
  global group
  global hostname
  global spooldir
  global antivirdir
  global tempdir
  global postmaster
  global smtpbanner
  global piddir
  global address
  global port
  global timeout
  global maxconnon
  global maxconn
  global maxsizeon
  global maxsize
  global maxrecon
  global maxrec
  global minfreeon
  global minfree
  global maxforward
  global maxnesting
  global maxattachments
  global blockmime
  global exposealerts
  global exposesenderalerts
  global exposepostmasteralerts
  global virusalertsuser
  global statusinbody
  global mimeconvert
  global pollperiod
  global scanarc
  global maxarcrec
  global maxarcrecon
  global maxarcsize
  global maxarcsizeon
  global blockarc
  global blockencarc
  global addxheader
  global addrheader
  global bouncemessageuser
  global scantimeout
  global externalprogram
  global forwardto
  global refuseemptyfrom
  global sourcerouting
  global addressbang
  global addresspercent
  global loosedomainname
    
  set File1 [open "/etc/avmailgate.conf" w]

  # Variablen schreiben
  puts $File1 "# Configuration file generated by TkAvGate 1.00.00 - Please do not modify!"

  puts $File1 "user\t\t$user"
  puts $File1 "group\t\t$group"
  if {[string compare "$hostname" ""] == 0} {    
    puts $File1 "#MyHostName mail.example.com"
  } else {
    puts $File1 "MyHostName\t$hostname"
  }
  puts $File1 "SpoolDir\t$spooldir"
  puts $File1 "AntiVirDir\t$antivirdir"
  if {[string compare "$tempdir" ""] == 0} {    
    puts $File1 "#TemporaryDir"
  } else {
    puts $File1 "TemporaryDir\t$tempdir"
  }
  puts $File1 "Postmaster\t$postmaster"
  puts $File1 "SMTPBanner\t\"$smtpbanner\""
  puts $File1 "PidDir\t$piddir"
  puts $File1 "ListenAddress\t$address port $port"
  puts $File1 "SmtpTimeout\t$timeout"
  if {[string compare "$maxconnon" "1"] == 0} {
    puts $File1 "MaxIncomingConnections\t$maxconn"
  } else {
    puts $File1 "MaxIncomingConnections\t0"      
  }
  if {[string compare "$maxsizeon" "1"] == 0} {
    puts $File1 "MaxMessageSize\t\t$maxsize"
  } else {
    puts $File1 "MaxMessageSize\t\t0"      
  }
  if {[string compare "$maxrecon" "1"] == 0} {
    puts $File1 "MaxRecipientsPerMessage\t$maxrec"
  } else {
    puts $File1 "#MaxRecipientsPerMessage100"      
  }
  if {[string compare "$minfreeon" "1"] == 0} {
    puts $File1 "MinFreeBlocks\t$maxrec"
  } else {
    puts $File1 "#MinFreeBlocks\t100"      
  }
  if {[string compare "$refuseemptyfrom" "1"] == 0} {
    puts $File1 "RefuseEmptyMailFrom\tYES"
  } else {
    puts $File1 "RefuseEmptyMailFrom\tNO"      
  }
  if {[string compare "$sourcerouting" "1"] == 0} {
    puts $File1 "AllowSourceRouting\tYES"
  } else {
    puts $File1 "AllowSourceRouting\tNO"      
  }
  puts $File1 "InEnvelopAddressesBangIs\t$addressbang"
  puts $File1 "InEnvelopAddressesPercentIs\t$addresspercent"
  if {[string compare "$loosedomainname" "1"] == 0} {
    puts $File1 "AcceptLooseDomainName\tYES"
  } else {
    puts $File1 "AcceptLooseDomainName\tNO"      
  }
  puts $File1 "MaxForwarders\t$maxforward"
  puts $File1 "MaxNestingLevel\t$maxnesting"
  puts $File1 "MaxAttachments\t$maxattachments"   
  if {[string compare "$blockmime" "1"] == 0} {
    puts $File1 "BlockSuspiciousMime\tYES"
  } else {
    puts $File1 "BlockSuspiciousMime\tNO"      
  }
  if {[string compare "$exposealerts" "1"] == 0} {
    puts $File1 "ExposeRecipientAlerts\tYES"
  } else {
    puts $File1 "ExposeRecipientAlerts\tNO"      
  }
  if {[string compare "$exposesenderalerts" "1"] == 0} {
    puts $File1 "ExposeSenderAlerts\tYES"
  } else {
    puts $File1 "ExposeSenderAlerts\tNO"      
  }
  if {[string compare "$exposepostmasteralerts" "1"] == 0} {
    puts $File1 "ExposePostmasterAlerts\tYES"
  } else {
    puts $File1 "ExposePostmasterAlerts\tNO"      
  }
  puts $File1 "VirusAlertsUser\t$virusalertsuser"
  if {[string compare "$forwardto" ""] == 0} {    
    puts $File1 "#ForwardTo"
  } else {
    puts $File1 "ForwardTo\t$forwardto"
  }
  if {[string compare "$statusinbody" "1"] == 0} {
    puts $File1 "AddStatusInBody\tYES"
  } else {
    puts $File1 "AddStatusinBody\tNO"      
  }
  if {[string compare "$mimeconvert" "1"] == 0} {
    puts $File1 "ForwardAllEmailAsMIME\tYES"
  } else {
    puts $File1 "ForwardAllEmailAsMIME\tNO"      
  }
  puts $File1 "PollPeriod\t$pollperiod"
  if {[string compare "$scanarc" "1"] == 0} {
    puts $File1 "ScanInArchive\tYES"
  } else {
    puts $File1 "ScanInArchive\tNO"      
  }
  if {[string compare "$maxarcsizeon" "1"] == 0} {
    puts $File1 "MaxFilesizeInArchive\t\t$maxarcsize"
  } else {
    puts $File1 "MaxFilesizeInArchive\t\t0"      
  }

  if {[string compare "$maxarcrecon" "1"] == 0} {
    puts $File1 "MaxRecursionDepthInArchive\t\t$maxarcrec"
  } else {
    puts $File1 "MaxRecursionDepthInArchive\t\t0"      
  }
  if {[string compare "$blockarc" "1"] == 0} {
    puts $File1 "BlockSuspiciousArchive\tYES"
  } else {
    puts $File1 "BlockSuspiciousArchive\tNO"      
  }
  if {[string compare "$blockencarc" "1"] == 0} {
    puts $File1 "BlockEncryptedArchive\tYES"
  } else {
    puts $File1 "BlockEncryptedArchive\tNO"      
  }
  puts $File1 "BounceMessageUser\t$bouncemessageuser"
  if {[string compare "$addxheader" "1"] == 0} {
    puts $File1 "AddXHeader\tYES"
  } else {
    puts $File1 "AddXHeader\tNO"      
  }
  if {[string compare "$addrheader" "1"] == 0} {
    puts $File1 "AddReceivedByHeader\tYES"
  } else {
    puts $File1 "AddReceivedByHeader\tNO"      
  }
  puts $File1 "ScanTimeout\t$scantimeout"
    
  if {[string compare "$externalprogram" ""] == 0} {    
    puts $File1 "# ExternalProgram\t/dir/myownscript"
  } else {
    puts $File1 "ExternalProgram\t$externalprogram"
  }
    
  puts $File1 "# END OF CONFIG FILE"
    
  close $File1

  gate_load

  update idletask
               
}


#####################################################################
# Beide AvGate-Teile im Hintergrund starten                         #
#####################################################################

proc gate_start {} {

  exec /sbin/startproc /usr/sbin/avgated
  exec /sbin/startproc /usr/sbin/avgatefwd
   
}


#####################################################################
# Beide AvGate-Teile im Hintergrund beenden                         #
#####################################################################

proc gate_stop {} {

  exec /sbin/killproc -TERM /usr/sbin/avgated
  exec /sbin/killproc -TERM /usr/sbin/avgatefwd

}


#####################################################################
# Beide AvGate-Teile im Hintergrund neu-starten                     #
#####################################################################

proc gate_restart {} {

  exec /sbin/killproc -TERM /usr/sbin/avgated
  exec /sbin/killproc -TERM /usr/sbin/avgatefwd
  exec /sbin/startproc /usr/sbin/avgated
  exec /sbin/startproc /usr/sbin/avgatefwd
   
}


#####################################################################
# Zeitanzeige in der Statuszeile                                    #
#####################################################################

proc update_time {} {
 global currenttime 

 set secs [clock seconds]
 set time [clock format $secs -format "%H:%M:%S"]

 set currenttime "$time"
 after 1000 update_time
}


#####################################################################
# Behandlung von E-Mail-Adressen                                    #
#####################################################################

proc AddressHandlingDlg {} {

  global sourcerouting
  global newsourcerouting
  global addressbang
  global newaddressbang
  global addresspercent
  global newaddresspercent    
  global loosedomainname
  global newloosedomainname
  global buttonpressed

  set newsourcerouting $sourcerouting
  set newaddressbang $addressbang
  set newaddresspercent $addresspercent
  set newloosedomainname $loosedomainname
    
  # Fenster erzeugen
  catch { destroy .handl }
  toplevel .handl -class Dialog
  wm title .handl "Behandlung von E-Mail-Adressen"
  wm geometry .handl +320+220

  # Dialogelemente im Fenster plazieren
  checkbutton .handl.source  -text "Source-Routing zulassen" -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-* -variable newsourcerouting
  
  frame .handl.bang
  label .handl.bang.desc -text "Ausrufezeichen in Envelope-Adresse  " -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*  
  tk_optionMenu .handl.bang.case newaddressbang "REFUSED" "IGNORED" "INTERPRETED"
  pack .handl.bang.desc .handl.bang.case -side left

  frame .handl.percent
  label .handl.percent.desc -text "Prozentzeichen in Envelope-Adresse  " -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*  
  tk_optionMenu .handl.percent.case newaddresspercent "REFUSED" "IGNORED" "INTERPRETED"
  pack .handl.percent.desc .handl.percent.case -side left

  checkbutton .handl.domain  -text "E-Mails mit ungltigen Domain-Name zulassen" -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-* -variable newloosedomainname
    
  # Buttonleiste
  frame .handl.button

  button .handl.button.ok -text "OK" \
                         -command "set buttonpressed 1" \
                         -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*

  button .handl.button.cancel -text "Abbrechen" \
                             -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-* \
                             -command "set buttonpressed 0"

  pack  .handl.button.ok .handl.button.cancel -side left -pady 1m -anchor ne

  pack .handl.source .handl.bang .handl.percent .handl.domain .handl.button -padx 2m -anchor nw

# Warten auf Button
tkwait variable buttonpressed

# wenn es der Ok-Button war, werden die Einstellungen uebernommen und mit write_preferences
# geschrieben
if {$buttonpressed == 1} {
   set sourcerouting $newsourcerouting
   set addressbang $newaddressbang
   set addresspercent $newaddresspercent
   set loosedomainname $newloosedomainname
   destroy .handl
} else {
   set newsourcerouting $sourcerouting
   set newaddressbang $addressbang
   set newaddresspercent $addresspercent
   set newloosedomainname $loosedomainname
   destroy .handl
}

}





#####################################################################
# Editor fr Zugriffslistendatei /etc/avmailgate.acl                #
#####################################################################

proc ACLEditor {} {
   
  global buttonpressededit

  catch { destroy .edit }
  toplevel .edit -class Dialog
  wm title .edit "ACL-Editor"
  wm geometry .edit +320+220

  
  frame .edit.l -relief flat -bd 0

  set scw 16
  listbox .edit.l.lst1 -selectmode single -yscroll ".edit.l.sb1 set" \
          -highlightthickness 0 -bg white -height 9 -font Courier
  scrollbar .edit.l.sb1 -command ".edit.l.lst1 yview" -highlightthickness 0
#  place .edit.l.lst1 -x 6 -relwidth 0.99 -width [expr -$scw - 10 ] \
#        -y 4  -relheight 10 -height -8
#  place .edit.l.sb1 -relx 0.99 -x [expr -$scw - 4 ] -width $scw -y 4  \
#        -relheight 0.98 -height -8

  pack .edit.l.sb1 -side right -fill y
  pack .edit.l.lst1 -fill x
  pack .edit.l -fill x
   
  frame .edit.button

  button .edit.button.add -text "Hinzufgen" \
                          -command "ACLAdd" \
                          -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
  button .edit.button.remove -text "Entfernen" \
                             -command "ACLRemove" \
                             -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
  button .edit.button.modify -text "Bearbeiten" \
                             -command "ACLModify" \
                             -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
  button .edit.button.ok -text "Schlieen" \
                             -command "set buttonpressededit 1" \
                             -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*

  pack .edit.button .edit.button.add .edit.button.modify .edit.button.remove .edit.button.ok -side left -pady 1m -padx 0.5m

  pack .edit.l .edit.button

  .edit.l.lst1 delete 0 end

  set file [open "/etc/avmailgate.acl" r]

  gets $file line
  while {! [eof $file]} {
	 .edit.l.lst1 insert end "$line" 
	 gets $file line
  }
  close $file
   
  # Warten auf Button
  tkwait variable buttonpressededit

  # wenn es der Ok-Button war, werden die Einstellungen uebernommen und mit write_preferences
  # geschrieben
  if {$buttonpressededit == 1} {
    ACLUpdate
    destroy .edit
  } else {
    destroy .edit
  }

}


proc ACLAdd {} {
   
  global inserttext
  global buttonpressedadd
  
  catch { destroy .acladd }
  toplevel .acladd -class Dialog
  wm title .acladd "Eintrag hinzufgen"
  wm geometry .acladd +300+300

  label .acladd.l -width 39 -text "Bitte geben Sie den einzufgendne Eintrag ein:        " \
                  -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
  entry .acladd.e -width 39 \
                  -relief sunken \
                  -bd 2 \
                  -textvariable inserttext \
                  -background white \
                  -font Courier

  button .acladd.button -text "   Hinzufgen   " \
                        -command "set buttonpressedadd 1" \
                        -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*

  pack .acladd.l .acladd.e .acladd.button -ipadx 3m -side top -anchor nw

  tkwait variable buttonpressedadd
     
  .edit.l.lst1 insert end $inserttext   

  if {$buttonpressedadd == 1} {
    destroy .acladd
  } else {
    destroy .acladd
  }
 
}


proc ACLRemove {} {

  set index [.edit.l.lst1 curselection]
  if { $index != "" } {
    set line [.edit.l.lst1 get $index]
    .edit.l.lst1 delete $index
  }

}


proc ACLModify {} {
  
  global modifytext
  global new_modifytext
  global buttonpressedmod

  set index [.edit.l.lst1 curselection]
  if { $index != "" } {
    set modifytext [.edit.l.lst1 get $index] 
     
    set new_modifytext $modifytext
     
    catch { destroy .aclmodify }
    toplevel .aclmodify -class Dialog
    wm title .aclmodify "Eintrag bearbeiten"
    wm geometry .aclmodify +300+300

    label .aclmodify.l -width 39 -text "Geben Sie hier nderungen fr diesen Eintrag an:    " \
                       -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
    entry .aclmodify.e -width 39 \
                       -relief sunken \
                       -bd 2 \
                       -textvariable new_modifytext \
                       -background white \
                       -font Courier

    button .aclmodify.button -text "   Eintrag ndern   " \
                             -command "set buttonpressedmod 1" \
                             -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*

    pack .aclmodify.l .aclmodify.e .aclmodify.button -ipadx 3m -side top -anchor nw

    tkwait variable buttonpressedmod
     
    .edit.l.lst1 delete $index
    .edit.l.lst1 insert $index $new_modifytext

    if {$buttonpressedmod == 1} {
      destroy .aclmodify
    } else {
      destroy .aclmodify
  }

  } 
     
}


proc ACLUpdate {} {
   
  set file [open "/etc/avmailgate.acl" w]

  set index 0
  set lastline [.edit.l.lst1 size]
  while { $index < $lastline } {
   	set line [.edit.l.lst1 get $index]
   	puts $file $line
   	incr index
  }

  close $file
   
}


#####################################################################
# HAUPTPROGRAMM - T k A v G a t e  1 . 0 0 . 0 0                    #
#####################################################################
gate_load

# BWidget 1.4.0 Bibliothek laden
# set path_to_tkavgate [file dirname tkavgate.tcl]
lappend auto_path "$path_to_tkavgate/BWidget-1.4.0"
package require BWidget 1.4.0
variable resources "de"
option read [file join $path_to_tkavgate "BWidget-1.4.0/lang" "$resources.rc"]

# ###################################################################
# Layout des Fensters
#
frame .menu -relief raised -bd 2
frame .links
frame .rechts
frame .nochrechter
frame .oben
frame .mitte
frame .unten

# ###################################################################
# Graue Titelleiste

frame .title -relief flat -bg gray68
label .title.text -text " Konfiguration des H+BEDV AntiVir MailGate" -bg gray68
pack .title .title.text -side left

# ###################################################################
# Elemente der linken Seite

NoteBook .chooser

set global [.chooser insert 1 global -text "Globale Einstellungen" -activebackground gray85]

frame $global.oben
frame $global.unten
frame $global.mitte
frame $global.rechts
frame $global.nochrechter

TitleFrame $global.allg -relief groove -text "Benutzer und Verzeichnisse" -font -*-Helvetica-Bold-R-Normal--*-120-*-*-*-*-*-*

set subf [$global.allg getframe]

frame $subf.user
                               
label $subf.user.l  -text "User/Gruppe  \t" -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
entry $subf.user.u  -width 10 \
                      -relief sunken \
			             -bd 2 \
               			    -textvariable user -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
label $subf.user.s  -text " / " -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*                               
entry $subf.user.g -width 10 \
                      -relief sunken \
			             -bd 2 \
               			    -textvariable group -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*


pack $subf.user.l $subf.user.u $subf.user.s $subf.user.g -side left

frame $subf.hostname
                               
label $subf.hostname.l  -text "Host-Name    \t" -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
entry $subf.hostname.e -width 24 \
                      -relief sunken \
			             -bd 2 \
               			    -textvariable hostname -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
                           
pack $subf.hostname.l $subf.hostname.e -side left


frame $subf.spooldir
                               
label $subf.spooldir.l  -text "Spool-Verz.   \t" -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
entry $subf.spooldir.e -width 24 \
                         -relief sunken \
			                -bd 2 \
                  			    -textvariable spooldir -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
                           
pack $subf.spooldir.l $subf.spooldir.e -side left

frame $subf.antivirdir
                               
label $subf.antivirdir.l  -text "AntiVir-Ver.   " -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
entry $subf.antivirdir.e -width 24 \
                         -relief sunken \
			                -bd 2 \
                  			    -textvariable antivirdir -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
                           
pack $subf.antivirdir.l $subf.antivirdir.e -side left

frame $subf.temporarydir

label $subf.temporarydir.l  -text "Temp. Verz.   " -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
entry $subf.temporarydir.e -width 24 \
                         -relief sunken \
			                -bd 2 \
                  			    -textvariable tempdir -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
                           
pack $subf.temporarydir.l $subf.temporarydir.e -side left


frame $subf.postmaster
                               
label $subf.postmaster.l  -text "Postmaster     " -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
entry $subf.postmaster.e -width 24 \
                           -relief sunken \
			                  -bd 2 \
                    			    -textvariable postmaster -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
                           
pack $subf.postmaster.l $subf.postmaster.e -side left

frame $subf.smtpbanner
                               
label $subf.smtpbanner.l  -text "SMTP-Banner" -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
entry $subf.smtpbanner.e -width 24 \
                           -relief sunken \
			                  -bd 2 \
                    			    -textvariable smtpbanner -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
                           
pack $subf.smtpbanner.l $subf.smtpbanner.e -side left

frame $subf.pid
                               
label $subf.pid.l  -text "PID-Verz.      \t" -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
entry $subf.pid.e -width 24 \
                    -relief sunken \
			           -bd 2 \
             			    -textvariable piddir -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
                           
pack $subf.pid.l $subf.pid.e -side left

frame $subf.matchmail
label $subf.matchmail.desc -text "Prozentzeichen in Envelope-Adresse  " -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*  
tk_optionMenu $subf.matchmail.case matchmail "RECIPIENT" "SENDER" "BOTH"
pack $subf.matchmail.desc $subf.matchmail.case -side left


pack $subf $subf.user $subf.hostname $subf.spooldir $subf.antivirdir $subf.temporarydir $subf.postmaster $subf.smtpbanner $subf.pid -anchor nw

label $global.space1 -text "  "

pack $global $global.allg $global.space1 -anchor nw

frame .end -relief groove -bd 2

label .end.titel -text "    " -font -*-Helvetica-Medium-R-Normal--*-10-*-*-*-*-*-*
button .end.button -text "   Programm beenden   " -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-* \
	    -command exit -justify center


# ###################################################################
# Elemente fuer Frame rechts

set gate [.chooser insert 1 gate -text "avgated Einstellungen" -activebackground gray85]

frame $gate.oben
frame $gate.unten
frame $gate.mitte
frame $gate.rechts
frame $gate.nochrechter

TitleFrame $gate.gateopt -relief groove -text "Grundeinstellungen" -font -*-Helvetica-Bold-R-Normal--*-120-*-*-*-*-*-*

set subf2 [$gate.gateopt getframe]
           
frame $subf2.adress
                               
label $subf2.adress.l  -text "IP-Adresse  \t" -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
entry $subf2.adress.e -width 31 \
                       -relief sunken \
                			    -bd 2 \
                			    -textvariable address -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*

pack $subf2.adress.l $subf2.adress.e -side left

frame $subf2.port
                               
label $subf2.port.l  -text "Port/Service\t" -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
entry $subf2.port.e -width 12 \
                     -relief sunken \
			            -bd 2 \
              			    -textvariable port -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*

label $subf2.port.l2  -text "  SMTP-Timeout " -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
entry $subf2.port.e2 -width 4 \
                      -relief sunken \
               			    -bd 2 \
               			    -textvariable timeout -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*

pack $subf2.port.l $subf2.port.e $subf2.port.l2 $subf2.port.e2 -side left

frame $subf2.maxconn
                               
checkbutton $subf2.maxconn.s  -text "Maximale Zahl eingehender Verbindungen  " -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-* -variable maxconnon
entry $subf2.maxconn.e -width 3 \
                        -relief sunken \
                   	    -bd 2 \
                        -textvariable maxconn -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*

pack $subf2.maxconn.s $subf2.maxconn.e -side left

frame $subf2.maxsize
                               
checkbutton $subf2.maxsize.s  -text "Maximale Gre der Nachrichten            " -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-* -variable maxsizeon
entry $subf2.maxsize.e -width 5 \
                        -relief sunken \
      	           		    -bd 2 \
                 			    -textvariable maxsize -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*

pack $subf2.maxsize.s $subf2.maxsize.e -side left

frame $subf2.maxrec
                               
checkbutton $subf2.maxrec.s  -text "Maximale Empfngerzahl pro Nachricht \t    " -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-* -variable maxrecon
entry $subf2.maxrec.e -width 4 \
                       -relief sunken \
			              -bd 2 \
                  	    -textvariable maxrec -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*

pack $subf2.maxrec.s $subf2.maxrec.e -side left

frame $subf2.minfree

checkbutton $subf2.minfree.s -text "Minimum an freien Blcke auf Dateisystem " -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-* -variable minfreeon
entry       $subf2.minfree.e -width 4 \
                              -relief sunken \
                        		    -bd 2 \
                        		    -textvariable minfree -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*

pack $subf2.minfree.s $subf2.minfree.e -side left

checkbutton $subf2.emptyfrom -text "E-Mails ohne Absender ignorieren" -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-* -variable refuseemptyfrom

frame $subf2.acledit
 
label $subf2.acledit.spacer -text "  " -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*

button $subf2.acledit.button -text "Editor fr Zugriffsliste avgatemail.acl" -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-* \
                       -command "ACLEditor"

pack $subf2.acledit.spacer $subf2.acledit.button -side left -pady 1m

frame $subf2.handling
 
label $subf2.handling.spacer -text "  " -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*

button $subf2.handling.button -text "Behandlung von E-Mail-Adressen " -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-* \
                       -command "AddressHandlingDlg"

pack $subf2.handling.spacer $subf2.handling.button -side left -pady 1m


pack $subf2 $subf2.adress $subf2.port $subf2.maxconn $subf2.maxsize \
     $subf2.maxrec \
     $subf2.minfree \
     $subf2.emptyfrom \
     $subf2.acledit \
     $subf2.handling \
     -anchor nw
     
# pack $gate.gateopt -in $gate.nochrechter

pack $gate $gate.gateopt -anchor nw

set fwd [.chooser insert 2 fwd -text "avgatefwd Einstellungen" -activebackground gray85]

frame $fwd.oben
frame $fwd.unten
frame $fwd.mitte
frame $fwd.rechts
frame $fwd.nochrechter

frame $fwd.main

TitleFrame $fwd.main.fwdopt -relief groove -text "Grundeinstellungen" -font -*-Helvetica-Bold-R-Normal--*-120-*-*-*-*-*-*

set subf4 [$fwd.main.fwdopt getframe]

frame $subf4.maxforward
                               
label $subf4.maxforward.l -text "Maximale Anzahl der Forwarder         " -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
entry $subf4.maxforward.e -width 3 \
                              -relief sunken \
		                   	    -bd 2 \
                        		    -textvariable maxforward -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
                           
pack $subf4.maxforward.l $subf4.maxforward.e -side left

frame $subf4.maxnesting
                               
label $subf4.maxnesting.l -text "Maximale Rekursionstiefe (MIME)       " -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
entry $subf4.maxnesting.e -width 3 \
                              -relief sunken \
		                   	    -bd 2 \
                        		    -textvariable maxnesting -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
                           
pack $subf4.maxnesting.l $subf4.maxnesting.e -side left

frame $subf4.maxattachments
                               
label $subf4.maxattachments.l -text "Maximale Anzahl an Mail-Anhngen  " -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
entry $subf4.maxattachments.e -width 3 \
                              -relief sunken \
		                   	    -bd 2 \
                        		    -textvariable maxattachments -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
                           
pack $subf4.maxattachments.l $subf4.maxattachments.e -side left


checkbutton $subf4.blockmime -text "Verdchtige MIME-Mails blockieren" -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-* -variable blockmime

checkbutton $subf4.exposealerts -text "Warnung an Empfnger infizierter Mails" -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-* -variable exposealerts

checkbutton $subf4.exposesenderalerts -text "Warnung an Absender infizierter Mails" -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-* -variable exposesenderalerts

checkbutton $subf4.exposepostmasteralerts -text "Virenwarnung an Postmaster senden" -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-* -variable exposepostmasteralerts

frame $subf4.to
                               
label $subf4.to.l -text "Forwarder\t" -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
entry $subf4.to.e -width 26 \
                      -relief sunken \
                 		   -bd 2 \
                			   -textvariable forwardto -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
                           
pack $subf4.to.l $subf4.to.e -side left

checkbutton $subf4.statusinbody -text "Status-Benachrichtigung in Mail-Body  " -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-* -variable statusinbody

checkbutton $subf4.mimeconvert -text "Mails immer als MIME-Mails weiterleiten" -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-* -variable mimeconvert

frame $subf4.period
                               
label $subf4.period.l1 -text "Queue alle " -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
entry $subf4.period.e -width 3 \
                      -relief sunken \
                 		   -bd 2 \
                			   -textvariable pollperiod -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
                               
label $subf4.period.l2 -text " Sekunden berprfen" -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
                           
pack $subf4.period.l1 $subf4.period.e $subf4.period.l2 -side left


frame $subf4.buto
                               
button $subf4.buto.b1 -text "sendmail" -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-* -command {set forwardto $forwardtosendmail; update} -pady 0.7

button $subf4.buto.b2 -text "SMTP" -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-* -command {set forwardto $forwardtosmtp; update} -pady 0.7

pack $subf4.buto.b1 $subf4.buto.b2 -side left -padx 9m -pady 1m


pack $subf4.maxforward $subf4.maxnesting $subf4.maxattachments $subf4.blockmime \
     $subf4.exposealerts $subf4.exposesenderalerts $subf4.exposepostmasteralerts $subf4.to $subf4.buto $subf4.statusinbody \
     $subf4.mimeconvert $subf4.period -anchor nw

frame $fwd.main.fwdoptgen

TitleFrame $fwd.main.fwdoptgen.fwdopt2 -relief groove -text "Archive" -font -*-Helvetica-Bold-R-Normal--*-120-*-*-*-*-*-*

set subf5 [$fwd.main.fwdoptgen.fwdopt2 getframe]

checkbutton $subf5.scanarc -text "Archivdateien durchsuchen" -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-* -variable scanarc

frame $subf5.maxarcrec

checkbutton $subf5.maxarcrec.s -text "Maximale Verzeichnistiefe von Archiven" -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-* -variable maxarcrecon
entry       $subf5.maxarcrec.e -width 4 \
                              -relief sunken \
                        		    -bd 2 \
                        		    -textvariable maxarcrec -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*

pack $subf5.maxarcrec.s $subf5.maxarcrec.e -side left

checkbutton $subf5.blockarc -text "Mails mit verdchtigen Archiven blockieren" -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-* -variable blockarc

checkbutton $subf5.blockencarc -text "Mails mit verschl. Dateien in Archiven blockieren" -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-* -variable blockencarc

frame $subf5.maxarcsize

checkbutton $subf5.maxarcsize.s -text "Max. Dateigre von Dateien in Archiven" -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-* -variable maxarcsizeon
entry       $subf5.maxarcsize.e -width 4 \
                              -relief sunken \
                        		    -bd 2 \
                        		    -textvariable maxarcsize -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*

pack $subf5.maxarcsize.s $subf5.maxarcsize.e -side left


pack $subf5 $subf5.scanarc $subf5.maxarcrec $subf5.blockarc $subf5.blockencarc $subf5.maxarcsize -anchor nw

TitleFrame $fwd.main.fwdoptgen.fwdopt3 -relief groove -text "Sonstiges" -font -*-Helvetica-Bold-R-Normal--*-120-*-*-*-*-*-*

set subf6 [$fwd.main.fwdoptgen.fwdopt3 getframe]

checkbutton $subf6.addxheader -text "X-Header hinzufgen" -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-* -variable addxheader

frame $subf6.bouncemessageuser

label $subf6.bouncemessageuser.l -text "Benutzername fr Fehler-Mails" -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
entry $subf6.bouncemessageuser.e -width 16 \
                              -relief sunken \
                        		    -bd 2 \
                        		    -textvariable bouncemessageuser -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*

pack $subf6.bouncemessageuser.l $subf6.bouncemessageuser.e -side left

frame $subf6.virusalertsuser

label $subf6.virusalertsuser.l -text "Absender fr Virenwarnungen " -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
entry $subf6.virusalertsuser.e -width 16 \
                              -relief sunken \
                        		    -bd 2 \
                        		    -textvariable virusalertsuser -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*

pack $subf6.virusalertsuser.l $subf6.virusalertsuser.e -side left


checkbutton $subf6.addrheader -text "Received by-Header hinzufgen" -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-* -variable addrheader

frame $subf6.scantimeout

label $subf6.scantimeout.l -text "Timeout fr das Scannen von Mails (in Sek.) " -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-* 
entry $subf6.scantimeout.e -width 5 \
                              -relief sunken \
                        		    -bd 2 \
                        		    -textvariable scantimeout -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*

pack $subf6.scantimeout.l $subf6.scantimeout.e -side left

frame $subf6.externalprogram

label $subf6.externalprogram.l -text "bei Virenfund ausfhren  " -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-* 
entry $subf6.externalprogram.e -width 21 \
                              -relief sunken \
                        		    -bd 2 \
                        		    -textvariable externalprogram -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*

pack $subf6.externalprogram.l $subf6.externalprogram.e -side left


pack $subf6 $subf6.bouncemessageuser $subf6.virusalertsuser $subf6.addxheader $subf6.addrheader $subf6.scantimeout $subf6.externalprogram -anchor nw

pack $fwd.main.fwdoptgen $fwd.main.fwdoptgen.fwdopt2 $fwd.main.fwdoptgen.fwdopt3 -anchor nw

pack $fwd.main.fwdoptgen $fwd.main.fwdopt -side right -padx 1m -anchor nw

pack $fwd $fwd.main -anchor nw

frame .buttons -relief groove -bd 2 
                  
# frame .buttons.but

label .buttons.titel -text "Programm-Funktionen"

pack .buttons.titel

button .buttons.but1 -text " Konfig. auslesen" -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-* \
              		          -command gate_load


button .buttons.but3 -text "  Dmon starten  " -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-* \
               		          -command gate_start
                                 

button .buttons.but2 -text  "Konfig. schreiben" -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-* \
		                   -command gate_save


button .buttons.but4 -text " Dmon stoppen " -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-* \
              		          -command gate_stop
                                
button .buttons.but5 -text "    Neu starten    " -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-* \
                 		          -command gate_restart
		     

button .buttons.but6 -text "     Schlieen     " -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-* \
               		          -command exit

pack .buttons .buttons.titel .buttons.but1 .buttons.but2 .buttons.but6 -anchor n

label	.tkavgate	-text "      TkAvGate 1.00\n    Tcl/Tk-Frontend fr AntiVir MailGate" \
              -foreground gray50 \
	       -font -*-Helvetica-Bold-R-Normal--*-120-*-*-*-*-*-*


# ###################################################################
# Elemente fuer Frame unten
frame .out -relief flat -bd 2 
                  
text .out.text -relief sunken -bd 2 -bg white

# pack .out .out.text

# Status-Leiste hinzufuegen
frame .statusBar
label .statusBar.big -text "TkAvGate 1.00.00 AvMailGate-Konfiguration - (C) 2001-2003 by Sebastian Geiges. Released under the GPL." -relief sunken -bd 1 \
                     -font -*-Helvetica-Medium-R-Normal--*-100-*-*-*-*-*-* -anchor w
label .statusBar.small -width 8 -relief sunken -bd 1 -textvariable currenttime \
                       -font -*-Helvetica-Medium-R-Normal--*-100-*-*-*-*-*-* -anchor w
pack .statusBar.big -side left -padx 2 -expand yes -fill both
pack .statusBar.small -side left -padx 2 -fill both

# ###################################################################
# Oberflaeche zusammenbasteln
wm title . "AntiVir MailGate-Konfiguration"
wm resizable . 1 1
wm geometry . +200+120

pack .mitte
pack .links .rechts .nochrechter -side left -in .mitte -anchor nw
pack .unten
pack .title -side top -fill x -padx 1.7m -pady 1.7m -ipady 1m -ipadx 1m

pack $global.oben
pack $global.unten
pack $global.mitte
pack $global.rechts $global.nochrechter -side left -in $global.mitte -anchor nw

pack $gate.oben
pack $gate.unten
pack $gate.mitte
pack $gate.rechts $gate.nochrechter -side left -in $gate.mitte -anchor nw

pack $fwd.oben
pack $fwd.unten
pack $fwd.mitte
pack $fwd.rechts $fwd.nochrechter -side left -in $fwd.mitte -anchor nw

pack .buttons -anchor nw -in .nochrechter -padx 2m -pady 2m -ipady 2m -side top
pack .statusBar -side top -fill x -pady 2

.chooser compute_size
pack .chooser -anchor n -fill x -in .rechts -pady 2m -padx 2m
.chooser raise global
.chooser raise gate
.chooser raise fwd
.chooser raise global

pack .statusBar -side top -fill x -pady 2 -expand yes

gate_load

update_time









































##TCLDevStudioProject
## Attention! Followed data is TCL Developer Studio Project information.
## All data from it place to TCLDevStudioProject_END will removed and rewritted during edition in TCLDevStudio.
## Do not edit it yourself!
#global tclDevData
#set tclDevData(project,version) 2
#set tclDevData(project,both,Name) "TkAvGate 1.00.00"
#set tclDevData(project,unix,Name) ""
#set tclDevData(project,windows,Name) ""
#set tclDevData(project,both,Dir) "/home/devel/data/tkavgate"
#set tclDevData(project,unix,Dir) ""
#set tclDevData(project,windows,Dir) ""
#set tclDevData(project,both,RunCmd) "/home/devel/data/tkavgate/tkavgate.tcl"
#set tclDevData(project,unix,RunCmd) "/home/devel/data/tkavgate/tkavgate.tcl"
#set tclDevData(project,windows,RunCmd) ""
#set tclDevData(project,both,DebugCmd) ""
#set tclDevData(project,unix,DebugCmd) ""
#set tclDevData(project,windows,DebugCmd) ""
#set tclDevData(project,both,FileComment) ""
#set tclDevData(project,unix,FileComment) ""
#set tclDevData(project,windows,FileComment) ""
##TCLDevStudioProject_END
